from database.backtest import backtest_results
from datetime import datetime, timedelta

def best_entry_times(date: datetime = datetime.now(), days_to_look_back: int = 10):
    end_date = date.replace(hour = 0, minute = 0, second = 0, microsecond = 0)
    end_date -= timedelta(days = 1) # Subtract one day in order to prevent lookahead bias.
    start_date = end_date - timedelta(days = days_to_look_back)

    backtest = backtest_results('SPX', '10 Delta Iron Condor', start_date = start_date, end_date = end_date)
    backtest['Entry Time'] = backtest['Entry Time'].dt.time

    profit_by_entry_time = backtest.groupby('Entry Time')['Profit'].sum().reset_index()

    best_entry_times = profit_by_entry_time.sort_values(by = 'Profit', ascending = False).head(10)
    return [str(entry_time) for entry_time in best_entry_times['Entry Time'].tolist()]